
package hindenburg;

import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;


public class Hindenburg {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int g = sc.nextInt();
        
        int[] arr = new int[n];
        
        for (int i = 1; i <= n; i++) 
        {
            arr[i-1] = sc.nextInt();
        }
        
        Arrays.sort(arr);
        
        int res_t = Integer.MAX_VALUE;
        for (int i = 0; i < n; i++) {
            
            int res = Integer.MAX_VALUE;
            
            for (int a = 0; a < g; a++) {                
                if ((i*g+a) > n -1)
                    break;
                                
                res &= arr[i*g+a];
            }
            res_t &= res;
        }
        
        System.out.println(res_t);
    }
    
}
